/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.prj3.beans;

import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author thierry
 */
@Entity
@Table(name = "PROJECT")

@NamedQueries({
    @NamedQuery(name = Project.PROJECT_FIND_ALL_PROJECTS, query = "SELECT dto FROM Project dto"),
    @NamedQuery(name = Project.PROJECT_FIND_BY_ID, query = "SELECT dto FROM Project dto where dto.projectId=:projectId"),
    @NamedQuery(name = Project.PROJECT_FIND_BY_NAME, query = "SELECT dto FROM Project dto where upper(dto.name) like upper (:pName)")
})

@XmlRootElement
public class Project {

    public static final String PROJECT_FIND_ALL_PROJECTS = "PROJECT_FIND_ALL";
    public static final String PROJECT_FIND_BY_ID = "PROJECT_FIND_BY_ID";
    public static final String PROJECT_FIND_BY_NAME = "PROJECT_FIND_BY_NAME";
    public static final String PROJECT_COUNT = "SELECT count(dto.projectId) FROM Project dto";

    public Project() {
    }
    
      public Project(Long projectId, String name, Date startDate, Date endDate) {
            this.projectId=projectId;
          this.name=name;
          this.startDate=startDate;
          this.endDate=endDate;
    }

    @Id
    @Column(name = "PROJECT_ID")
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long projectId;

    @Column(name = "NAME", unique = true, nullable = false)
    private String name;

    @Temporal(TemporalType.DATE)
    @Column(nullable = true)
    private Date startDate ;
            
    @Temporal(TemporalType.DATE)
    @Column(nullable = true)
    private Date endDate;

    public Long getProjectId() {
        return projectId;
    }

    public void setProjectId(Long projectId) {
        this.projectId = projectId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String toString() {
        return "Project : name=" + name;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    public Date getEndDate() {
        return endDate;
    }

    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

}
